--------------------------------------------------------------------------------
-- Company: 
-- Engineer:
--
-- Create Date:    21:47:59 02/23/06
-- Design Name:    
-- Module Name:    adder - rtl
-- Project Name:   
-- Target Device:  
-- Tool versions:  
-- Description:
--
-- Dependencies:
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
-- 
--------------------------------------------------------------------------------
library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;
use ieee.std_logic_misc.all;
use work.user_pkg.all;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity adder is
	port (
		in_user_clk			: in  std_logic;
		in_reset_n			: in  std_logic;

		-- Data Inputs (generate PWM_COL_BITS data input lines...)
		in_data_00			: in  std_logic_vector(RESOLUTION_INPUT-1 downto 0);
		in_data_01			: in  std_logic_vector(RESOLUTION_INPUT-1 downto 0);
		in_data_02			: in  std_logic_vector(RESOLUTION_INPUT-1 downto 0);
		in_data_03			: in  std_logic_vector(RESOLUTION_INPUT-1 downto 0);
		in_data_04			: in  std_logic_vector(RESOLUTION_INPUT-1 downto 0);
		in_data_05			: in  std_logic_vector(RESOLUTION_INPUT-1 downto 0);
		in_data_06			: in  std_logic_vector(RESOLUTION_INPUT-1 downto 0);
		in_data_07			: in  std_logic_vector(RESOLUTION_INPUT-1 downto 0);
		--in_index				: in  std_logic_vector(INDEX_BITS-1 downto 0);
		
		-- Output lines
		out_data				: out std_logic_vector(RESOLUTION_OUTPUT-1 downto 0)
		--out_index			: out std_logic_vector(INDEX_BITS-1 downto 0)

		--debug					: out std_logic_vector(63 downto 0)
	);
end adder;

architecture rtl of adder is
 	signal buffer_data_00 		: std_logic_vector(RESOLUTION_OUTPUT-1 downto 0);
	signal buffer_data_01 		: std_logic_vector(RESOLUTION_OUTPUT-1 downto 0);
	signal buffer_data_02 		: std_logic_vector(RESOLUTION_OUTPUT-1 downto 0);
	signal buffer_data_03 		: std_logic_vector(RESOLUTION_OUTPUT-1 downto 0);
	signal buffer_data_04 		: std_logic_vector(RESOLUTION_OUTPUT-1 downto 0);
	signal buffer_data_05 		: std_logic_vector(RESOLUTION_OUTPUT-1 downto 0);
	signal buffer_data_06 		: std_logic_vector(RESOLUTION_OUTPUT-1 downto 0);
	signal buffer_data_07 		: std_logic_vector(RESOLUTION_OUTPUT-1 downto 0);

	signal buffer_data_00_01 	: std_logic_vector(RESOLUTION_OUTPUT-1 downto 0);
	signal buffer_data_02_03 	: std_logic_vector(RESOLUTION_OUTPUT-1 downto 0);
	signal buffer_data_04_05 	: std_logic_vector(RESOLUTION_OUTPUT-1 downto 0);
	signal buffer_data_06_07 	: std_logic_vector(RESOLUTION_OUTPUT-1 downto 0);

 	signal buffer_data_00_03 	: std_logic_vector(RESOLUTION_OUTPUT-1 downto 0);
	signal buffer_data_04_07 	: std_logic_vector(RESOLUTION_OUTPUT-1 downto 0);

	--signal buffer_index_in		: std_logic_vector(INDEX_BITS-1 downto 0);
	--signal buffer_index_l1		: std_logic_vector(INDEX_BITS-1 downto 0);
	--signal buffer_index_l2		: std_logic_vector(INDEX_BITS-1 downto 0);

	signal debug : std_logic_vector(63 downto 0);	   
begin
	 input_buffer : process (in_user_clk, in_reset_n) is
	 begin
	 	if in_reset_n='0' then
			buffer_data_00 	<= (others => '0');
			buffer_data_01 	<= (others => '0');
			buffer_data_02 	<= (others => '0');
			buffer_data_03 	<= (others => '0');
			buffer_data_04 	<= (others => '0');
			buffer_data_05 	<= (others => '0');
			buffer_data_06 	<= (others => '0');
			buffer_data_07 	<= (others => '0');
	--		buffer_index_in	<= (others => '0');
	 	elsif in_user_clk='1' and in_user_clk'event then
			buffer_data_00(RESOLUTION_INPUT-1 downto 0) <= in_data_00;
			buffer_data_01(RESOLUTION_INPUT-1 downto 0) <= in_data_01;
			buffer_data_02(RESOLUTION_INPUT-1 downto 0) <= in_data_02;
			buffer_data_03(RESOLUTION_INPUT-1 downto 0) <= in_data_03;
			buffer_data_04(RESOLUTION_INPUT-1 downto 0) <= in_data_04;
			buffer_data_05(RESOLUTION_INPUT-1 downto 0) <= in_data_05;
			buffer_data_06(RESOLUTION_INPUT-1 downto 0) <= in_data_06;
			buffer_data_07(RESOLUTION_INPUT-1 downto 0) <= in_data_07;
	--		buffer_index_in	<= in_index;
		end if;
	 end process input_buffer;

	 add_level1	: process (in_user_clk, in_reset_n) is
	 begin
		if in_reset_n='0' then
			buffer_data_00_01	<= (others => '0');
			buffer_data_02_03	<= (others => '0');
			buffer_data_04_05	<= (others => '0');
			buffer_data_06_07	<= (others => '0');
	--		buffer_index_l1	<= (others => '0');
		elsif in_user_clk='1' and in_user_clk'event then
			buffer_data_00_01 <= buffer_data_00 + buffer_data_01;
			buffer_data_02_03 <= buffer_data_02 + buffer_data_03;
			buffer_data_04_05 <= buffer_data_04 + buffer_data_05;
			buffer_data_06_07 <= buffer_data_06 + buffer_data_07;
	--		buffer_index_l1	<= buffer_index_in;
		end if;	
	 end process add_level1;

	 add_level2	: process (in_user_clk, in_reset_n) is
	 begin
	 	if in_reset_n='0' then
			buffer_data_00_03	<= (others => '0');
			buffer_data_04_07	<= (others => '0');
	--		buffer_index_l2	<= (others => '0');
	 	elsif in_user_clk='1' and in_user_clk'event then
			buffer_data_00_03 <= buffer_data_00_01 + buffer_data_02_03;
			buffer_data_04_07 <= buffer_data_04_05 + buffer_data_06_07;
	--		buffer_index_l2 	<= buffer_index_l1;
		end if;	
	 end process add_level2;

	 add_level3	: process (in_user_clk, in_reset_n) is
	 begin
	 	if in_reset_n='0' then
			out_data				<= (others => '0');
	--		out_index			<= (others => '0');
			debug <= (others => '0');
		elsif in_user_clk='1' and in_user_clk'event then
			out_data 			<= buffer_data_00_03 + buffer_data_04_07;
	--		out_index 			<= buffer_index_l2;

			--debug(31 downto 0) <= buffer_data_00_03(31 downto 0) + buffer_data_04_07(31 downto 0);

--			debug(INDEX_BITS-1 downto 0) <= in_index(INDEX_BITS-1 downto 0);
--			debug(32+INDEX_BITS-1 downto 32) <= buffer_index_l2(INDEX_BITS-1 downto 0);

			--debug(7 downto 0) <= in_data_00(7 downto 0);
			--debug(15 downto 8) <= in_data_01(7 downto 0);
			--debug(23 downto 16) <= in_data_02(7 downto 0);
			--debug(31 downto 24) <= in_data_03(7 downto 0);
			--debug(39 downto 32) <= in_data_04(7 downto 0);
			--debug(47 downto 40) <= in_data_05(7 downto 0);
			--debug(55 downto 48) <= in_data_06(7 downto 0);
			--debug(63 downto 56) <= in_data_07(7 downto 0);
		end if;	
	 end process add_level3;

end rtl;
