--------------------------------------------------------------------------------
-- Company: 
-- Engineer:
--
-- Create Date:    00:01:07 02/24/06
-- Design Name:    
-- Module Name:    resqueue - rtl
-- Project Name:   
-- Target Device:  
-- Tool versions:  
-- Description:
--
-- Dependencies:
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
-- 
--------------------------------------------------------------------------------
library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;
use ieee.std_logic_misc.all;
use work.user_pkg.all;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity resqueue is
	port(
		in_user_clk		: in  std_logic;
		in_reset_n		: in  std_logic;

	 	-- Input signals
		in_data			: in  std_logic_vector(RESOLUTION_OUTPUT-1 downto 0);
		in_index			: in  std_logic_vector(INDEX_BITS-1 downto 0);

	  	-- Flags to tell resqueue to write results to RT, and where
		in_done			: in  std_logic;
		in_ftr_ptr		: in  std_logic_vector(39 downto 3);

		-- RT user request interface
	   ureq_srctag   	: in  std_logic_vector(4 downto 0);
	   ureq_full     	: in  std_logic;
	   ureq_notag    	: in  std_logic;
	   ureq_addr     	: out std_logic_vector(39 downto 3);
	   ureq_size     	: out std_logic_vector(2 downto 0);
	   ureq_mask     	: out std_logic_vector(7 downto 0);
	   ureq_data     	: out std_logic_vector(63 downto 0);
	   ureq_rw_n     	: out std_logic;
	   ureq_ts       	: out std_logic;
	   ureq_byte_req 	: out std_logic

		--debug				: out std_logic_vector(63 downto 0)

--		p_elem_00_gt	: out std_logic;
--		p_elem_01_gt	: out std_logic;
--		p_elem_02_gt	: out std_logic;
--		p_elem_03_gt	: out std_logic;

--		p_val_00			: out std_logic_vector(RESOLUTION_OUTPUT-1 downto 0);
--		p_val_01			: out std_logic_vector(RESOLUTION_OUTPUT-1 downto 0);
--		p_val_02			: out std_logic_vector(RESOLUTION_OUTPUT-1 downto 0);
--		p_val_03			: out std_logic_vector(RESOLUTION_OUTPUT-1 downto 0)
	);

end resqueue;

architecture rtl of resqueue is
	signal rescounter : std_logic_vector(7 downto 0) := "00000000";

	signal last_in_value	: std_logic_vector(RESOLUTION_OUTPUT-1 downto 0);
	signal last_in_index	: std_logic_vector(INDEX_BITS-1 downto 0);	-- 2 bit flag (not set | error) + 24 bit index

	signal elem_00_gt		: std_logic;
	signal elem_00_value	: std_logic_vector(RESOLUTION_OUTPUT-1 downto 0);
	signal elem_00_index	: std_logic_vector(INDEX_BITS-1 downto 0);

	signal elem_01_gt		: std_logic;
	signal elem_01_value	: std_logic_vector(RESOLUTION_OUTPUT-1 downto 0);
	signal elem_01_index	: std_logic_vector(INDEX_BITS-1 downto 0);

	signal elem_02_gt		: std_logic;
	signal elem_02_value	: std_logic_vector(RESOLUTION_OUTPUT-1 downto 0);
	signal elem_02_index	: std_logic_vector(INDEX_BITS-1 downto 0);

	signal elem_03_gt		: std_logic;
	signal elem_03_value	: std_logic_vector(RESOLUTION_OUTPUT-1 downto 0);
	signal elem_03_index	: std_logic_vector(INDEX_BITS-1 downto 0);

	signal elem_04_gt		: std_logic;
	signal elem_04_value	: std_logic_vector(RESOLUTION_OUTPUT-1 downto 0);
	signal elem_04_index	: std_logic_vector(INDEX_BITS-1 downto 0);

	signal elem_05_gt		: std_logic;
	signal elem_05_value	: std_logic_vector(RESOLUTION_OUTPUT-1 downto 0);
	signal elem_05_index	: std_logic_vector(INDEX_BITS-1 downto 0);

	signal elem_06_gt		: std_logic;
	signal elem_06_value	: std_logic_vector(RESOLUTION_OUTPUT-1 downto 0);
	signal elem_06_index	: std_logic_vector(INDEX_BITS-1 downto 0);

	signal elem_07_gt		: std_logic;
	signal elem_07_value	: std_logic_vector(RESOLUTION_OUTPUT-1 downto 0);
	signal elem_07_index	: std_logic_vector(INDEX_BITS-1 downto 0);

	signal writing : std_logic;																				

	signal debug : std_logic_vector(63 downto 0);
begin
	main : process (in_user_clk, in_reset_n) is
	begin
		if in_reset_n='0' then
			last_in_value <= (others => '0');
			last_in_index <= (others => '0');
			--debug <= (others => '0');
		elsif in_user_clk='1' and in_user_clk'event then
			last_in_value <= in_data;
			last_in_index <= in_index-14;

--			debug(63 downto RESOLUTION_OUTPUT)  <= in_index-14;
--			debug(RESOLUTION_OUTPUT-1 downto 0) <= in_data;

			--debug(7 downto 0) <= elem_00_index(7 downto 0);
			--debug(15 downto 8) <= elem_01_index(7 downto 0);
			--debug(23 downto 16) <= elem_02_index(7 downto 0);
			--debug(31 downto 24) <= elem_03_index(7 downto 0);
			--debug(39 downto 32) <= elem_04_index(7 downto 0);
			--debug(47 downto 40) <= elem_05_index(7 downto 0);
			--debug(55 downto 48) <= elem_06_index(7 downto 0);
			--debug(63 downto 56) <= elem_07_index(7 downto 0);

--			p_elem_00_gt <= elem_00_gt;
--			p_elem_01_gt <= elem_01_gt;			
--			p_elem_02_gt <= elem_02_gt;			
--			p_elem_03_gt <= elem_03_gt;
--			p_val_00 <= elem_00_value;
--			p_val_01 <= elem_01_value;
--			p_val_02 <= elem_02_value;
--			p_val_03 <= elem_03_value;
		end if;		
	end process main;

	output : process (in_user_clk, in_reset_n) is
	begin
		if in_reset_n='0' then
		   ureq_addr     	<= (others => '0');
		   ureq_size     	<= (others => '0');
		   ureq_mask     	<= (others => '0');
		   ureq_data     	<= (others => '0');
		   ureq_rw_n     	<= '0';
		   ureq_ts       	<= '0';
		   ureq_byte_req 	<= '0';
			rescounter		<= "00000000";
			debug <= (others => '0');
		elsif in_user_clk='1' and in_user_clk'event then
			debug(0) <= '1';
			if in_done='1' or writing='1' then
				debug(1) <= '1';
				if rescounter="00000000" then
					debug(2) <= '1';
					-- start burst
					ureq_addr <= in_ftr_ptr;
 					ureq_size <= "111";
					ureq_ts <= '1';
 					writing <= '1';

 					ureq_data(63 downto 63-INDEX_BITS+1)  <= elem_00_index;
					ureq_data(RESOLUTION_OUTPUT-1 downto 0) <= elem_00_value;
 
					--ureq_addr(INDEX_BITS+2 downto 3) <= elem_00_index;
					--ureq_data(RESOLUTION_OUTPUT-1 downto 0) <= elem_00_value;
					rescounter <= "00000001";
				elsif rescounter="00000001" then
					debug(3) <= '1';
					ureq_addr <= (others => '0');
					ureq_size <= (others => '0');
					ureq_ts <= '0';

					ureq_data(63 downto 63-INDEX_BITS+1)  <= elem_01_index;
					ureq_data(RESOLUTION_OUTPUT-1 downto 0) <= elem_01_value;
 
					--ureq_addr(INDEX_BITS+2 downto 3) <= elem_01_index;
					--ureq_data(RESOLUTION_OUTPUT-1 downto 0) <= elem_01_value;
					rescounter <= "00000010";
				elsif rescounter="00000010" then
					debug(4) <= '1';
					ureq_data(63 downto 63-INDEX_BITS+1)  <= elem_02_index;
					ureq_data(RESOLUTION_OUTPUT-1 downto 0) <= elem_02_value;
 
 					--ureq_addr(INDEX_BITS+2 downto 3) <= elem_02_index;
					--ureq_data(RESOLUTION_OUTPUT-1 downto 0) <= elem_02_value;
					rescounter <= "00000011";
				elsif rescounter="00000011" then
					debug(5) <= '1';
					ureq_data(63 downto 63-INDEX_BITS+1)  <= elem_03_index;
					ureq_data(RESOLUTION_OUTPUT-1 downto 0) <= elem_03_value;
 
 					--ureq_addr(INDEX_BITS+2 downto 3) <= elem_03_index;
					--ureq_data(RESOLUTION_OUTPUT-1 downto 0) <= elem_03_value;
					rescounter <= "00000100";
				elsif rescounter="00000100" then
					debug(6) <= '1';
					ureq_data(63 downto 63-INDEX_BITS+1)  <= elem_04_index;
					ureq_data(RESOLUTION_OUTPUT-1 downto 0) <= elem_04_value;
 
 					--ureq_addr(INDEX_BITS+2 downto 3) <= elem_04_index;
					--ureq_data(RESOLUTION_OUTPUT-1 downto 0) <= elem_04_value;
					rescounter <= "00000101";
				elsif rescounter="00000101" then
					debug(7) <= '1';
					ureq_data(63 downto 63-INDEX_BITS+1)  <= elem_05_index;
					ureq_data(RESOLUTION_OUTPUT-1 downto 0) <= elem_05_value;
 
 					--ureq_addr(INDEX_BITS+2 downto 3) <= elem_05_index;
					--ureq_data(RESOLUTION_OUTPUT-1 downto 0) <= elem_05_value;
					rescounter <= "00000110";
				elsif rescounter="00000110" then
					debug(8) <= '1';
					ureq_data(63 downto 63-INDEX_BITS+1)  <= elem_06_index;
					ureq_data(RESOLUTION_OUTPUT-1 downto 0) <= elem_06_value;
 
 					--ureq_addr(INDEX_BITS+2 downto 3) <= elem_06_index;
					--ureq_data(RESOLUTION_OUTPUT-1 downto 0) <= elem_06_value;
					rescounter <= "00000111";
				elsif rescounter="00000111" then
					debug(9) <= '1';
					ureq_data(63 downto 63-INDEX_BITS+1)  <= elem_07_index;
					ureq_data(RESOLUTION_OUTPUT-1 downto 0) <= elem_07_value;
 
 					--ureq_addr(INDEX_BITS+2 downto 3) <= elem_07_index;
					--ureq_data(RESOLUTION_OUTPUT-1 downto 0) <= elem_07_value;
					rescounter <= "11111111";
				else
					debug(10) <= '1';
					ureq_addr <= (others => '0');
					ureq_data <= (others => '0');
 					ureq_size <= (others => '0');
					ureq_ts <= '0';
					writing <= '0';				
					rescounter		<= "00000000";
				end if;	
			end if;
		end if;	
	end process output;

	elem_00 : process (in_user_clk, in_reset_n) is	-- min
	begin
		if in_reset_n='0' then
			elem_00_gt		<= '0';
			elem_00_value 	<= (others => '0');
			elem_00_index 	<= (others => '1');
		elsif in_user_clk='1' and in_user_clk'event then				
			if elem_00_gt='1' then
				if	elem_01_gt='1' then
					elem_00_value <= elem_01_value;
					elem_00_index <= elem_01_index;
					if elem_01_value < in_data then
						elem_00_gt <= '1';
					else
						elem_00_gt <= '0';			
					end if;
				else
					elem_00_value <= last_in_value;
					elem_00_index <= last_in_index;	
					if last_in_value < in_data then
						elem_00_gt <= '1';
					else
						elem_00_gt <= '0';			
					end if;
				end if;
			else
				if elem_00_value < in_data then
					elem_00_gt <= '1';
				else
					elem_00_gt <= '0';			
				end if;
			end if;	
		end if;
	end process elem_00;

	elem_01 : process (in_user_clk, in_reset_n) is
	begin
		if in_reset_n='0' then
			elem_01_gt		<= '0';
			elem_01_value 	<= (others => '0');
			elem_01_index 	<= (others => '1');
		elsif in_user_clk='1' and in_user_clk'event then				
			if elem_01_gt='1' then
				if	elem_02_gt='1' then
					elem_01_value <= elem_02_value;
					elem_01_index <= elem_02_index;
					if elem_02_value < in_data then
						elem_01_gt <= '1';
					else
						elem_01_gt <= '0';			
					end if;
				else
					elem_01_value <= last_in_value;
					elem_01_index <= last_in_index;	
					if last_in_value < in_data then
						elem_01_gt <= '1';
					else
						elem_01_gt <= '0';
					end if;
				end if;
			else
				if elem_01_value < in_data then
					elem_01_gt <= '1';
				else
					elem_01_gt <= '0';
				end if;
			end if;	
		end if;
	end process elem_01;

	elem_02 : process (in_user_clk, in_reset_n) is
	begin
		if in_reset_n='0' then
			elem_02_gt		<= '0';
			elem_02_value 	<= (others => '0');
			elem_02_index 	<= (others => '1');	
		elsif in_user_clk='1' and in_user_clk'event then				
			if elem_02_gt='1' then
				if	elem_03_gt='1' then
					elem_02_value <= elem_03_value;
					elem_02_index <= elem_03_index;
					if elem_03_value < in_data then
						elem_02_gt <= '1';
					else
						elem_02_gt <= '0';
					end if;
				else
					elem_02_value <= last_in_value;
					elem_02_index <= last_in_index;	
					if last_in_value < in_data then
						elem_02_gt <= '1';
					else
						elem_02_gt <= '0';
					end if;
				end if;
			else
				if elem_02_value < in_data then
					elem_02_gt <= '1';
				else
					elem_02_gt <= '0';
				end if;
			end if;	
		end if;
	end process elem_02;

	elem_03 : process (in_user_clk, in_reset_n) is
	begin
		if in_reset_n='0' then
			elem_03_gt		<= '0';
			elem_03_value 	<= (others => '0');
			elem_03_index 	<= (others => '1');	
		elsif in_user_clk='1' and in_user_clk'event then				
			if elem_03_gt='1' then
				if	elem_04_gt='1' then
					elem_03_value <= elem_04_value;
					elem_03_index <= elem_04_index;
					if elem_04_value < in_data then
						elem_03_gt <= '1';
					else
						elem_03_gt <= '0';
					end if;
				else
					elem_03_value <= last_in_value;
					elem_03_index <= last_in_index;	
					if last_in_value < in_data then
						elem_03_gt <= '1';
					else
						elem_03_gt <= '0';
					end if;
				end if;
			else
				if elem_03_value < in_data then
					elem_03_gt <= '1';
				else
					elem_03_gt <= '0';
				end if;
			end if;	
		end if;
	end process elem_03;

	elem_04 : process (in_user_clk, in_reset_n) is
	begin
		if in_reset_n='0' then
			elem_04_gt		<= '0';
			elem_04_value 	<= (others => '0');
			elem_04_index 	<= (others => '1');	
		elsif in_user_clk='1' and in_user_clk'event then				
			if elem_04_gt='1' then
				if	elem_05_gt='1' then
					elem_04_value <= elem_05_value;
					elem_04_index <= elem_05_index;
					if elem_05_value < in_data then
						elem_04_gt <= '1';
					else
						elem_04_gt <= '0';
					end if;
				else
					elem_04_value <= last_in_value;
					elem_04_index <= last_in_index;	
					if last_in_value < in_data then
						elem_04_gt <= '1';
					else
						elem_04_gt <= '0';
					end if;
				end if;
			else
				if elem_04_value < in_data then
					elem_04_gt <= '1';
				else
					elem_04_gt <= '0';
				end if;
			end if;	
		end if;
	end process elem_04;

	elem_05 : process (in_user_clk, in_reset_n) is
	begin
		if in_reset_n='0' then
			elem_05_gt		<= '0';
			elem_05_value 	<= (others => '0');
			elem_05_index 	<= (others => '1');	
		elsif in_user_clk='1' and in_user_clk'event then				
			if elem_05_gt='1' then
				if	elem_06_gt='1' then
					elem_05_value <= elem_06_value;
					elem_05_index <= elem_06_index;
					if elem_06_value < in_data then
						elem_05_gt <= '1';
					else
						elem_05_gt <= '0';
					end if;
				else
					elem_05_value <= last_in_value;
					elem_05_index <= last_in_index;	
					if last_in_value < in_data then
						elem_05_gt <= '1';
					else
						elem_05_gt <= '0';
					end if;
				end if;
			else
				if elem_05_value < in_data then
					elem_05_gt <= '1';
				else
					elem_05_gt <= '0';
				end if;
			end if;	
		end if;
	end process elem_05;

	elem_06 : process (in_user_clk, in_reset_n) is
	begin
		if in_reset_n='0' then
			elem_06_gt		<= '0';
			elem_06_value 	<= (others => '0');
			elem_06_index 	<= (others => '1');	
		elsif in_user_clk='1' and in_user_clk'event then				
			if elem_06_gt='1' then
				if	elem_07_gt='1' then
					elem_06_value <= elem_07_value;
					elem_06_index <= elem_07_index;
					if elem_07_value < in_data then
						elem_06_gt <= '1';
					else
						elem_06_gt <= '0';
					end if;
				else
					elem_06_value <= last_in_value;
					elem_06_index <= last_in_index;	
					if last_in_value < in_data then
						elem_06_gt <= '1';
					else
						elem_06_gt <= '0';
					end if;
				end if;
			else
				if elem_06_value < in_data then
					elem_06_gt <= '1';
				else
					elem_06_gt <= '0';
				end if;
			end if;	
		end if;
	end process elem_06;

	elem_07 : process (in_user_clk, in_reset_n) is	-- max
	begin
		if in_reset_n='0' then
			elem_07_gt		<= '0';
			elem_07_value 	<= (others => '0');
			elem_07_index 	<= (others => '1');	
		elsif in_user_clk='1' and in_user_clk'event then				
			if elem_07_gt='1' then
				elem_07_value <= last_in_value;
				elem_07_index <= last_in_index;	
				if last_in_value < in_data then
					elem_07_gt <= '1';
				else
					elem_07_gt <= '0';
				end if;
			else
				if elem_07_value < in_data then
					elem_07_gt <= '1';
				else
					elem_07_gt <= '0';
				end if;
			end if;	
		end if;
	end process elem_07;


end rtl;
