-------------------------------------------------------------------------------
-- Title      : User Application Package File
-- Project    : 
-------------------------------------------------------------------------------
-- File       : $RCSfile: user_pkg.vhd,v $
-- Author     : Cray Canada
-- Company    : Cray Canada Inc.
-- Created    : 2005-01-04
-- Last update: 2005-01-04
-------------------------------------------------------------------------------
-- Description: This package file is intended to contain constants, types,
-- functions and procedures used in multiple locations throughout the design.
-------------------------------------------------------------------------------
-- Copyright (c) 2005 Cray Canada Inc.
-------------------------------------------------------------------------------
-- Revisions  :
-- $Log: user_pkg.vhd,v $
-- Revision 1.1  2005/01/04 20:53:11 
-- Initial checkin.
--
-------------------------------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_misc.all;
use ieee.numeric_std.all;

package user_pkg is

  -----------------------------------------------------------------------------
  -- Declare Constants
  -----------------------------------------------------------------------------

  -- Declare the template design base number, variant number, revision number,
  -- and compile number.  
  constant c_tmpl_base : std_logic_vector(15 downto 0) := x"0008";
  constant c_tmpl_var  : std_logic_vector(7 downto 0)  := x"01";
  constant c_tmpl_rev  : std_logic_vector(7 downto 0)  := x"01";
  constant c_tmpl_comp : std_logic_vector(7 downto 0)  := x"06";

  constant RESOLUTION_INPUT 	: integer := 32;
  constant RESOLUTION_OUTPUT	: integer := 38;
  constant PWM_ROWS				: integer := 4;
  constant PWM_ROW_BITS			: integer := 2;
  constant PWM_COLS				: integer := 8;
  constant PWM_COL_BITS			: integer := 3;
  constant INDEX_BITS			: integer := 26;
  constant PIPELINE_COOLDOWN	: integer := 10;
 
  -----------------------------------------------------------------------------
  -- Declare Types
  -----------------------------------------------------------------------------

  --type PWM_mem_row is array(0 to PWM_COLS-1) of std_logic_vector(RESOLUTION_INPUT-1 downto 0); 
  type PWM_mem is array(0 to PWM_COLS-1, 0 to PWM_ROWS-1) of std_logic_vector(RESOLUTION_INPUT-1 downto 0);

  -----------------------------------------------------------------------------
  -- Declare function and procedure prototypes.
  -----------------------------------------------------------------------------

end package user_pkg;

package body user_pkg is

  -----------------------------------------------------------------------------
  -- Put any shared functions and procedures in here.
  -----------------------------------------------------------------------------

end package body user_pkg;
