--------------------------------------------------------------------------------
-- Copyright (c) 1995-2003 Xilinx, Inc.
-- All Right Reserved.
--------------------------------------------------------------------------------
--   ____  ____ 
--  /   /\/   / 
-- /___/  \  /    Vendor: Xilinx 
-- \   \   \/     Version : 7.1.04i
--  \   \         Application : ISE Foundation
--  /   /         Filename : control_tbw.vhw
-- /___/   /\     Timestamp : Sat Apr 15 11:01:29 2006
-- \   \  /  \ 
--  \___\/\___\ 
--
--Command: 
--Design Name: control_tbw
--Device: Xilinx
--

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;
use ieee.std_logic_misc.all;
library work;
use work.user_pkg.all;
USE IEEE.STD_LOGIC_TEXTIO.ALL;
USE STD.TEXTIO.ALL;

ENTITY control_tbw IS
END control_tbw;

ARCHITECTURE testbench_arch OF control_tbw IS
    FILE RESULTS: TEXT OPEN WRITE_MODE IS "results.txt";

    COMPONENT control
        PORT (
            in_reset_n : In std_logic;
            in_user_clk : In std_logic;
            in_user_enable : In std_logic;
            in_rt_ready : In std_logic;
            in_qdr_ready : In std_logic;
            out_mem_read_enable : Out std_logic;
            out_mem_read_index : Out std_logic_vector (25 DownTo 0);
            out_done : Out std_logic;
            out_ftr_ptr : Out std_logic_vector (39 DownTo 3);
            out_write_mem_index : Out std_logic_vector (25 DownTo 0);
            out_write_mem_data : Out std_logic_vector (63 DownTo 0);
            out_write_mem_strobe : Out std_logic;
            out_pwm_write_col_sel : Out std_logic_vector (2 DownTo 0);
            out_pwm_write_row_sel : Out std_logic_vector (1 DownTo 0);
            out_pwm_write_data : Out std_logic_vector (31 DownTo 0);
            out_pwm_write_strobe : Out std_logic;
            freq_addr : In std_logic_vector (39 DownTo 3);
            freq_size : In std_logic_vector (3 DownTo 0);
            freq_srctag : In std_logic_vector (4 DownTo 0);
            freq_mask : In std_logic_vector (7 DownTo 0);
            freq_data : In std_logic_vector (63 DownTo 0);
            freq_rw_n : In std_logic;
            freq_ts : In std_logic;
            freq_valid : In std_logic;
            freq_enable : Out std_logic;
            uresp_full : In std_logic;
            uresp_ts : Out std_logic;
            uresp_size : Out std_logic_vector (3 DownTo 0);
            uresp_srctag : Out std_logic_vector (4 DownTo 0);
            uresp_data : Out std_logic_vector (63 DownTo 0)
        );
    END COMPONENT;

    SIGNAL in_reset_n : std_logic := '0';
    SIGNAL in_user_clk : std_logic := '0';
    SIGNAL in_user_enable : std_logic := '0';
    SIGNAL in_rt_ready : std_logic := '0';
    SIGNAL in_qdr_ready : std_logic := '0';
    SIGNAL out_mem_read_enable : std_logic := '0';
    SIGNAL out_mem_read_index : std_logic_vector (25 DownTo 0) := "00000000000000000000000000";
    SIGNAL out_done : std_logic := '0';
    SIGNAL out_ftr_ptr : std_logic_vector (39 DownTo 3) := "0000000000000000000000000000000000000";
    SIGNAL out_write_mem_index : std_logic_vector (25 DownTo 0) := "00000000000000000000000000";
    SIGNAL out_write_mem_data : std_logic_vector (63 DownTo 0) := "0000000000000000000000000000000000000000000000000000000000000000";
    SIGNAL out_write_mem_strobe : std_logic := '0';
    SIGNAL out_pwm_write_col_sel : std_logic_vector (2 DownTo 0) := "000";
    SIGNAL out_pwm_write_row_sel : std_logic_vector (1 DownTo 0) := "00";
    SIGNAL out_pwm_write_data : std_logic_vector (31 DownTo 0) := "00000000000000000000000000000000";
    SIGNAL out_pwm_write_strobe : std_logic := '0';
    SIGNAL freq_addr : std_logic_vector (39 DownTo 3) := "0000000000000000000000000000000000000";
    SIGNAL freq_size : std_logic_vector (3 DownTo 0) := "0000";
    SIGNAL freq_srctag : std_logic_vector (4 DownTo 0) := "00000";
    SIGNAL freq_mask : std_logic_vector (7 DownTo 0) := "00000000";
    SIGNAL freq_data : std_logic_vector (63 DownTo 0) := "0000000000000000000000000000000000000000000000000000000000000000";
    SIGNAL freq_rw_n : std_logic := '0';
    SIGNAL freq_ts : std_logic := '0';
    SIGNAL freq_valid : std_logic := '0';
    SIGNAL freq_enable : std_logic := '0';
    SIGNAL uresp_full : std_logic := '0';
    SIGNAL uresp_ts : std_logic := '0';
    SIGNAL uresp_size : std_logic_vector (3 DownTo 0) := "0000";
    SIGNAL uresp_srctag : std_logic_vector (4 DownTo 0) := "00000";
    SIGNAL uresp_data : std_logic_vector (63 DownTo 0) := "0000000000000000000000000000000000000000000000000000000000000000";

    SHARED VARIABLE TX_ERROR : INTEGER := 0;
    SHARED VARIABLE TX_OUT : LINE;

    constant PERIOD : time := 200 ns;
    constant DUTY_CYCLE : real := 0.5;
    constant OFFSET : time := 0 ns;

    BEGIN
        UUT : control
        PORT MAP (
            in_reset_n => in_reset_n,
            in_user_clk => in_user_clk,
            in_user_enable => in_user_enable,
            in_rt_ready => in_rt_ready,
            in_qdr_ready => in_qdr_ready,
            out_mem_read_enable => out_mem_read_enable,
            out_mem_read_index => out_mem_read_index,
            out_done => out_done,
            out_ftr_ptr => out_ftr_ptr,
            out_write_mem_index => out_write_mem_index,
            out_write_mem_data => out_write_mem_data,
            out_write_mem_strobe => out_write_mem_strobe,
            out_pwm_write_col_sel => out_pwm_write_col_sel,
            out_pwm_write_row_sel => out_pwm_write_row_sel,
            out_pwm_write_data => out_pwm_write_data,
            out_pwm_write_strobe => out_pwm_write_strobe,
            freq_addr => freq_addr,
            freq_size => freq_size,
            freq_srctag => freq_srctag,
            freq_mask => freq_mask,
            freq_data => freq_data,
            freq_rw_n => freq_rw_n,
            freq_ts => freq_ts,
            freq_valid => freq_valid,
            freq_enable => freq_enable,
            uresp_full => uresp_full,
            uresp_ts => uresp_ts,
            uresp_size => uresp_size,
            uresp_srctag => uresp_srctag,
            uresp_data => uresp_data
        );

        PROCESS    -- clock process for in_user_clk
        BEGIN
            WAIT for OFFSET;
            CLOCK_LOOP : LOOP
                in_user_clk <= '0';
                WAIT FOR (PERIOD - (PERIOD * DUTY_CYCLE));
                in_user_clk <= '1';
                WAIT FOR (PERIOD * DUTY_CYCLE);
            END LOOP CLOCK_LOOP;
        END PROCESS;

        PROCESS
            PROCEDURE CHECK_freq_enable(
                next_freq_enable : std_logic;
                TX_TIME : INTEGER
            ) IS
                VARIABLE TX_STR : String(1 to 4096);
                VARIABLE TX_LOC : LINE;
                BEGIN
                IF (freq_enable /= next_freq_enable) THEN
                    STD.TEXTIO.write(TX_LOC, string'("Error at time="));
                    STD.TEXTIO.write(TX_LOC, TX_TIME);
                    STD.TEXTIO.write(TX_LOC, string'("ns freq_enable="));
                    IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, freq_enable);
                    STD.TEXTIO.write(TX_LOC, string'(", Expected = "));
                    IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, next_freq_enable);
                    STD.TEXTIO.write(TX_LOC, string'(" "));
                    TX_STR(TX_LOC.all'range) := TX_LOC.all;
                    STD.TEXTIO.writeline(RESULTS, TX_LOC);
                    STD.TEXTIO.Deallocate(TX_LOC);
                    ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
                    TX_ERROR := TX_ERROR + 1;
                END IF;
            END;
            PROCEDURE CHECK_out_done(
                next_out_done : std_logic;
                TX_TIME : INTEGER
            ) IS
                VARIABLE TX_STR : String(1 to 4096);
                VARIABLE TX_LOC : LINE;
                BEGIN
                IF (out_done /= next_out_done) THEN
                    STD.TEXTIO.write(TX_LOC, string'("Error at time="));
                    STD.TEXTIO.write(TX_LOC, TX_TIME);
                    STD.TEXTIO.write(TX_LOC, string'("ns out_done="));
                    IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, out_done);
                    STD.TEXTIO.write(TX_LOC, string'(", Expected = "));
                    IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, next_out_done);
                    STD.TEXTIO.write(TX_LOC, string'(" "));
                    TX_STR(TX_LOC.all'range) := TX_LOC.all;
                    STD.TEXTIO.writeline(RESULTS, TX_LOC);
                    STD.TEXTIO.Deallocate(TX_LOC);
                    ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
                    TX_ERROR := TX_ERROR + 1;
                END IF;
            END;
            PROCEDURE CHECK_out_ftr_ptr(
                next_out_ftr_ptr : std_logic_vector (39 DownTo 3);
                TX_TIME : INTEGER
            ) IS
                VARIABLE TX_STR : String(1 to 4096);
                VARIABLE TX_LOC : LINE;
                BEGIN
                IF (out_ftr_ptr /= next_out_ftr_ptr) THEN
                    STD.TEXTIO.write(TX_LOC, string'("Error at time="));
                    STD.TEXTIO.write(TX_LOC, TX_TIME);
                    STD.TEXTIO.write(TX_LOC, string'("ns out_ftr_ptr="));
                    IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, out_ftr_ptr);
                    STD.TEXTIO.write(TX_LOC, string'(", Expected = "));
                    IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, next_out_ftr_ptr);
                    STD.TEXTIO.write(TX_LOC, string'(" "));
                    TX_STR(TX_LOC.all'range) := TX_LOC.all;
                    STD.TEXTIO.writeline(RESULTS, TX_LOC);
                    STD.TEXTIO.Deallocate(TX_LOC);
                    ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
                    TX_ERROR := TX_ERROR + 1;
                END IF;
            END;
            PROCEDURE CHECK_out_mem_read_enable(
                next_out_mem_read_enable : std_logic;
                TX_TIME : INTEGER
            ) IS
                VARIABLE TX_STR : String(1 to 4096);
                VARIABLE TX_LOC : LINE;
                BEGIN
                IF (out_mem_read_enable /= next_out_mem_read_enable) THEN
                    STD.TEXTIO.write(TX_LOC, string'("Error at time="));
                    STD.TEXTIO.write(TX_LOC, TX_TIME);
                    STD.TEXTIO.write(TX_LOC, string'("ns out_mem_read_enable="));
                    IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, out_mem_read_enable);
                    STD.TEXTIO.write(TX_LOC, string'(", Expected = "));
                    IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, next_out_mem_read_enable);
                    STD.TEXTIO.write(TX_LOC, string'(" "));
                    TX_STR(TX_LOC.all'range) := TX_LOC.all;
                    STD.TEXTIO.writeline(RESULTS, TX_LOC);
                    STD.TEXTIO.Deallocate(TX_LOC);
                    ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
                    TX_ERROR := TX_ERROR + 1;
                END IF;
            END;
            PROCEDURE CHECK_out_mem_read_index(
                next_out_mem_read_index : std_logic_vector (25 DownTo 0);
                TX_TIME : INTEGER
            ) IS
                VARIABLE TX_STR : String(1 to 4096);
                VARIABLE TX_LOC : LINE;
                BEGIN
                IF (out_mem_read_index /= next_out_mem_read_index) THEN
                    STD.TEXTIO.write(TX_LOC, string'("Error at time="));
                    STD.TEXTIO.write(TX_LOC, TX_TIME);
                    STD.TEXTIO.write(TX_LOC, string'("ns out_mem_read_index="));
                    IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, out_mem_read_index);
                    STD.TEXTIO.write(TX_LOC, string'(", Expected = "));
                    IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, next_out_mem_read_index);
                    STD.TEXTIO.write(TX_LOC, string'(" "));
                    TX_STR(TX_LOC.all'range) := TX_LOC.all;
                    STD.TEXTIO.writeline(RESULTS, TX_LOC);
                    STD.TEXTIO.Deallocate(TX_LOC);
                    ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
                    TX_ERROR := TX_ERROR + 1;
                END IF;
            END;
            PROCEDURE CHECK_out_pwm_write_col_sel(
                next_out_pwm_write_col_sel : std_logic_vector (2 DownTo 0);
                TX_TIME : INTEGER
            ) IS
                VARIABLE TX_STR : String(1 to 4096);
                VARIABLE TX_LOC : LINE;
                BEGIN
                IF (out_pwm_write_col_sel /= next_out_pwm_write_col_sel) THEN
                    STD.TEXTIO.write(TX_LOC, string'("Error at time="));
                    STD.TEXTIO.write(TX_LOC, TX_TIME);
                    STD.TEXTIO.write(TX_LOC, string'("ns out_pwm_write_col_sel="));
                    IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, out_pwm_write_col_sel);
                    STD.TEXTIO.write(TX_LOC, string'(", Expected = "));
                    IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, next_out_pwm_write_col_sel);
                    STD.TEXTIO.write(TX_LOC, string'(" "));
                    TX_STR(TX_LOC.all'range) := TX_LOC.all;
                    STD.TEXTIO.writeline(RESULTS, TX_LOC);
                    STD.TEXTIO.Deallocate(TX_LOC);
                    ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
                    TX_ERROR := TX_ERROR + 1;
                END IF;
            END;
            PROCEDURE CHECK_out_pwm_write_data(
                next_out_pwm_write_data : std_logic_vector (31 DownTo 0);
                TX_TIME : INTEGER
            ) IS
                VARIABLE TX_STR : String(1 to 4096);
                VARIABLE TX_LOC : LINE;
                BEGIN
                IF (out_pwm_write_data /= next_out_pwm_write_data) THEN
                    STD.TEXTIO.write(TX_LOC, string'("Error at time="));
                    STD.TEXTIO.write(TX_LOC, TX_TIME);
                    STD.TEXTIO.write(TX_LOC, string'("ns out_pwm_write_data="));
                    IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, out_pwm_write_data);
                    STD.TEXTIO.write(TX_LOC, string'(", Expected = "));
                    IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, next_out_pwm_write_data);
                    STD.TEXTIO.write(TX_LOC, string'(" "));
                    TX_STR(TX_LOC.all'range) := TX_LOC.all;
                    STD.TEXTIO.writeline(RESULTS, TX_LOC);
                    STD.TEXTIO.Deallocate(TX_LOC);
                    ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
                    TX_ERROR := TX_ERROR + 1;
                END IF;
            END;
            PROCEDURE CHECK_out_pwm_write_row_sel(
                next_out_pwm_write_row_sel : std_logic_vector (1 DownTo 0);
                TX_TIME : INTEGER
            ) IS
                VARIABLE TX_STR : String(1 to 4096);
                VARIABLE TX_LOC : LINE;
                BEGIN
                IF (out_pwm_write_row_sel /= next_out_pwm_write_row_sel) THEN
                    STD.TEXTIO.write(TX_LOC, string'("Error at time="));
                    STD.TEXTIO.write(TX_LOC, TX_TIME);
                    STD.TEXTIO.write(TX_LOC, string'("ns out_pwm_write_row_sel="));
                    IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, out_pwm_write_row_sel);
                    STD.TEXTIO.write(TX_LOC, string'(", Expected = "));
                    IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, next_out_pwm_write_row_sel);
                    STD.TEXTIO.write(TX_LOC, string'(" "));
                    TX_STR(TX_LOC.all'range) := TX_LOC.all;
                    STD.TEXTIO.writeline(RESULTS, TX_LOC);
                    STD.TEXTIO.Deallocate(TX_LOC);
                    ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
                    TX_ERROR := TX_ERROR + 1;
                END IF;
            END;
            PROCEDURE CHECK_out_pwm_write_strobe(
                next_out_pwm_write_strobe : std_logic;
                TX_TIME : INTEGER
            ) IS
                VARIABLE TX_STR : String(1 to 4096);
                VARIABLE TX_LOC : LINE;
                BEGIN
                IF (out_pwm_write_strobe /= next_out_pwm_write_strobe) THEN
                    STD.TEXTIO.write(TX_LOC, string'("Error at time="));
                    STD.TEXTIO.write(TX_LOC, TX_TIME);
                    STD.TEXTIO.write(TX_LOC, string'("ns out_pwm_write_strobe="));
                    IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, out_pwm_write_strobe);
                    STD.TEXTIO.write(TX_LOC, string'(", Expected = "));
                    IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, next_out_pwm_write_strobe);
                    STD.TEXTIO.write(TX_LOC, string'(" "));
                    TX_STR(TX_LOC.all'range) := TX_LOC.all;
                    STD.TEXTIO.writeline(RESULTS, TX_LOC);
                    STD.TEXTIO.Deallocate(TX_LOC);
                    ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
                    TX_ERROR := TX_ERROR + 1;
                END IF;
            END;
            PROCEDURE CHECK_out_write_mem_data(
                next_out_write_mem_data : std_logic_vector (63 DownTo 0);
                TX_TIME : INTEGER
            ) IS
                VARIABLE TX_STR : String(1 to 4096);
                VARIABLE TX_LOC : LINE;
                BEGIN
                IF (out_write_mem_data /= next_out_write_mem_data) THEN
                    STD.TEXTIO.write(TX_LOC, string'("Error at time="));
                    STD.TEXTIO.write(TX_LOC, TX_TIME);
                    STD.TEXTIO.write(TX_LOC, string'("ns out_write_mem_data="));
                    IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, out_write_mem_data);
                    STD.TEXTIO.write(TX_LOC, string'(", Expected = "));
                    IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, next_out_write_mem_data);
                    STD.TEXTIO.write(TX_LOC, string'(" "));
                    TX_STR(TX_LOC.all'range) := TX_LOC.all;
                    STD.TEXTIO.writeline(RESULTS, TX_LOC);
                    STD.TEXTIO.Deallocate(TX_LOC);
                    ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
                    TX_ERROR := TX_ERROR + 1;
                END IF;
            END;
            PROCEDURE CHECK_out_write_mem_index(
                next_out_write_mem_index : std_logic_vector (25 DownTo 0);
                TX_TIME : INTEGER
            ) IS
                VARIABLE TX_STR : String(1 to 4096);
                VARIABLE TX_LOC : LINE;
                BEGIN
                IF (out_write_mem_index /= next_out_write_mem_index) THEN
                    STD.TEXTIO.write(TX_LOC, string'("Error at time="));
                    STD.TEXTIO.write(TX_LOC, TX_TIME);
                    STD.TEXTIO.write(TX_LOC, string'("ns out_write_mem_index="));
                    IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, out_write_mem_index);
                    STD.TEXTIO.write(TX_LOC, string'(", Expected = "));
                    IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, next_out_write_mem_index);
                    STD.TEXTIO.write(TX_LOC, string'(" "));
                    TX_STR(TX_LOC.all'range) := TX_LOC.all;
                    STD.TEXTIO.writeline(RESULTS, TX_LOC);
                    STD.TEXTIO.Deallocate(TX_LOC);
                    ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
                    TX_ERROR := TX_ERROR + 1;
                END IF;
            END;
            PROCEDURE CHECK_out_write_mem_strobe(
                next_out_write_mem_strobe : std_logic;
                TX_TIME : INTEGER
            ) IS
                VARIABLE TX_STR : String(1 to 4096);
                VARIABLE TX_LOC : LINE;
                BEGIN
                IF (out_write_mem_strobe /= next_out_write_mem_strobe) THEN
                    STD.TEXTIO.write(TX_LOC, string'("Error at time="));
                    STD.TEXTIO.write(TX_LOC, TX_TIME);
                    STD.TEXTIO.write(TX_LOC, string'("ns out_write_mem_strobe="));
                    IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, out_write_mem_strobe);
                    STD.TEXTIO.write(TX_LOC, string'(", Expected = "));
                    IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, next_out_write_mem_strobe);
                    STD.TEXTIO.write(TX_LOC, string'(" "));
                    TX_STR(TX_LOC.all'range) := TX_LOC.all;
                    STD.TEXTIO.writeline(RESULTS, TX_LOC);
                    STD.TEXTIO.Deallocate(TX_LOC);
                    ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
                    TX_ERROR := TX_ERROR + 1;
                END IF;
            END;
            PROCEDURE CHECK_uresp_data(
                next_uresp_data : std_logic_vector (63 DownTo 0);
                TX_TIME : INTEGER
            ) IS
                VARIABLE TX_STR : String(1 to 4096);
                VARIABLE TX_LOC : LINE;
                BEGIN
                IF (uresp_data /= next_uresp_data) THEN
                    STD.TEXTIO.write(TX_LOC, string'("Error at time="));
                    STD.TEXTIO.write(TX_LOC, TX_TIME);
                    STD.TEXTIO.write(TX_LOC, string'("ns uresp_data="));
                    IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, uresp_data);
                    STD.TEXTIO.write(TX_LOC, string'(", Expected = "));
                    IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, next_uresp_data);
                    STD.TEXTIO.write(TX_LOC, string'(" "));
                    TX_STR(TX_LOC.all'range) := TX_LOC.all;
                    STD.TEXTIO.writeline(RESULTS, TX_LOC);
                    STD.TEXTIO.Deallocate(TX_LOC);
                    ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
                    TX_ERROR := TX_ERROR + 1;
                END IF;
            END;
            PROCEDURE CHECK_uresp_size(
                next_uresp_size : std_logic_vector (3 DownTo 0);
                TX_TIME : INTEGER
            ) IS
                VARIABLE TX_STR : String(1 to 4096);
                VARIABLE TX_LOC : LINE;
                BEGIN
                IF (uresp_size /= next_uresp_size) THEN
                    STD.TEXTIO.write(TX_LOC, string'("Error at time="));
                    STD.TEXTIO.write(TX_LOC, TX_TIME);
                    STD.TEXTIO.write(TX_LOC, string'("ns uresp_size="));
                    IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, uresp_size);
                    STD.TEXTIO.write(TX_LOC, string'(", Expected = "));
                    IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, next_uresp_size);
                    STD.TEXTIO.write(TX_LOC, string'(" "));
                    TX_STR(TX_LOC.all'range) := TX_LOC.all;
                    STD.TEXTIO.writeline(RESULTS, TX_LOC);
                    STD.TEXTIO.Deallocate(TX_LOC);
                    ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
                    TX_ERROR := TX_ERROR + 1;
                END IF;
            END;
            PROCEDURE CHECK_uresp_srctag(
                next_uresp_srctag : std_logic_vector (4 DownTo 0);
                TX_TIME : INTEGER
            ) IS
                VARIABLE TX_STR : String(1 to 4096);
                VARIABLE TX_LOC : LINE;
                BEGIN
                IF (uresp_srctag /= next_uresp_srctag) THEN
                    STD.TEXTIO.write(TX_LOC, string'("Error at time="));
                    STD.TEXTIO.write(TX_LOC, TX_TIME);
                    STD.TEXTIO.write(TX_LOC, string'("ns uresp_srctag="));
                    IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, uresp_srctag);
                    STD.TEXTIO.write(TX_LOC, string'(", Expected = "));
                    IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, next_uresp_srctag);
                    STD.TEXTIO.write(TX_LOC, string'(" "));
                    TX_STR(TX_LOC.all'range) := TX_LOC.all;
                    STD.TEXTIO.writeline(RESULTS, TX_LOC);
                    STD.TEXTIO.Deallocate(TX_LOC);
                    ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
                    TX_ERROR := TX_ERROR + 1;
                END IF;
            END;
            PROCEDURE CHECK_uresp_ts(
                next_uresp_ts : std_logic;
                TX_TIME : INTEGER
            ) IS
                VARIABLE TX_STR : String(1 to 4096);
                VARIABLE TX_LOC : LINE;
                BEGIN
                IF (uresp_ts /= next_uresp_ts) THEN
                    STD.TEXTIO.write(TX_LOC, string'("Error at time="));
                    STD.TEXTIO.write(TX_LOC, TX_TIME);
                    STD.TEXTIO.write(TX_LOC, string'("ns uresp_ts="));
                    IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, uresp_ts);
                    STD.TEXTIO.write(TX_LOC, string'(", Expected = "));
                    IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, next_uresp_ts);
                    STD.TEXTIO.write(TX_LOC, string'(" "));
                    TX_STR(TX_LOC.all'range) := TX_LOC.all;
                    STD.TEXTIO.writeline(RESULTS, TX_LOC);
                    STD.TEXTIO.Deallocate(TX_LOC);
                    ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
                    TX_ERROR := TX_ERROR + 1;
                END IF;
            END;
            BEGIN
                -- -------------  Current Time:  85ns
                WAIT FOR 85 ns;
                in_reset_n <= '1';
                -- -------------------------------------
                -- -------------  Current Time:  485ns
                WAIT FOR 400 ns;
                in_qdr_ready <= '1';
                in_rt_ready <= '1';
                in_user_enable <= '1';
                -- -------------------------------------
                -- -------------  Current Time:  515ns
                WAIT FOR 30 ns;
                CHECK_freq_enable('1', 515);
                -- -------------------------------------
                -- -------------  Current Time:  1085ns
                WAIT FOR 570 ns;
                freq_ts <= '1';
                freq_valid <= '1';
                freq_addr <= "0000000000000000000000000000000000100";
                freq_data <= "0000000000000000000000000000000000000000000000000000000000010000";
                -- -------------------------------------
                -- -------------  Current Time:  1285ns
                WAIT FOR 200 ns;
                freq_ts <= '0';
                freq_valid <= '0';
                freq_addr <= "0000000000000000000000000000000000000";
                freq_data <= "0000000000000000000000000000000000000000000000000000000000000000";
                -- -------------------------------------
                -- -------------  Current Time:  1485ns
                WAIT FOR 200 ns;
                freq_ts <= '1';
                freq_valid <= '1';
                freq_addr <= "0000000000000000000000000000000000101";
                freq_data <= "0000000000000000000000000000000000000000000000000000000000011000";
                -- -------------------------------------
                -- -------------  Current Time:  1685ns
                WAIT FOR 200 ns;
                freq_ts <= '0';
                freq_valid <= '0';
                freq_addr <= "0000000000000000000000000000000000000";
                -- -------------------------------------
                -- -------------  Current Time:  1885ns
                WAIT FOR 200 ns;
                freq_ts <= '1';
                freq_valid <= '1';
                freq_addr <= "0000000000000000000000000000000000110";
                freq_data <= "0000000000000000000000000000000000000000000000000000000000100000";
                -- -------------------------------------
                -- -------------  Current Time:  2085ns
                WAIT FOR 200 ns;
                freq_ts <= '0';
                freq_valid <= '0';
                freq_addr <= "0000000000000000000000000000000000000";
                freq_data <= "0000000000000000000000000000000000000000000000000000000000000000";
                -- -------------------------------------
                -- -------------  Current Time:  2115ns
                WAIT FOR 30 ns;
                CHECK_out_ftr_ptr("0000000000000000000000000000000000100", 2115);
                -- -------------------------------------
                -- -------------  Current Time:  2285ns
                WAIT FOR 170 ns;
                freq_ts <= '1';
                freq_valid <= '1';
                freq_addr <= "0000000000000010000000000000000000000";
                freq_data <= "0000000000000000000000000000000000000000000000000000000000000001";
                freq_size <= "0011";
                -- -------------------------------------
                -- -------------  Current Time:  2485ns
                WAIT FOR 200 ns;
                freq_ts <= '0';
                freq_addr <= "0000000000000000000000000000000000000";
                freq_data <= "0000000000000000000000000000000000000000000000000000000000000010";
                freq_size <= "0000";
                -- -------------------------------------
                -- -------------  Current Time:  2515ns
                WAIT FOR 30 ns;
                CHECK_out_pwm_write_strobe('1', 2515);
                CHECK_out_pwm_write_data("00000000000000000000000000000001", 2515);
                -- -------------------------------------
                -- -------------  Current Time:  2685ns
                WAIT FOR 170 ns;
                freq_data <= "0000000000000000000000000000000000000000000000000000000000000011";
                -- -------------------------------------
                -- -------------  Current Time:  2715ns
                WAIT FOR 30 ns;
                CHECK_out_pwm_write_col_sel("001", 2715);
                CHECK_out_pwm_write_data("00000000000000000000000000000010", 2715);
                -- -------------------------------------
                -- -------------  Current Time:  2885ns
                WAIT FOR 170 ns;
                freq_data <= "0000000000000000000000000000000000000000000000000000000000000100";
                -- -------------------------------------
                -- -------------  Current Time:  2915ns
                WAIT FOR 30 ns;
                CHECK_out_pwm_write_col_sel("010", 2915);
                CHECK_out_pwm_write_data("00000000000000000000000000000011", 2915);
                -- -------------------------------------
                -- -------------  Current Time:  3085ns
                WAIT FOR 170 ns;
                freq_valid <= '0';
                freq_data <= "0000000000000000000000000000000000000000000000000000000000000000";
                -- -------------------------------------
                -- -------------  Current Time:  3115ns
                WAIT FOR 30 ns;
                CHECK_out_pwm_write_col_sel("011", 3115);
                CHECK_out_pwm_write_data("00000000000000000000000000000100", 3115);
                -- -------------------------------------
                -- -------------  Current Time:  3285ns
                WAIT FOR 170 ns;
                freq_ts <= '1';
                freq_valid <= '1';
                freq_addr <= "0000000000000100000000000000000000000";
                freq_data <= "0000000000000000000000000000000000000000000000000000000000000001";
                freq_size <= "0011";
                -- -------------------------------------
                -- -------------  Current Time:  3315ns
                WAIT FOR 30 ns;
                CHECK_out_pwm_write_strobe('0', 3315);
                -- -------------------------------------
                -- -------------  Current Time:  3485ns
                WAIT FOR 170 ns;
                freq_ts <= '0';
                freq_addr <= "0000000000000000000000000000000000000";
                freq_data <= "0000000000000000000000000000000000000000000000000000000000000010";
                freq_size <= "0000";
                -- -------------------------------------
                -- -------------  Current Time:  3515ns
                WAIT FOR 30 ns;
                CHECK_out_write_mem_strobe('1', 3515);
                CHECK_out_write_mem_data("0000000000000000000000000000000000000000000000000000000000000001", 3515);
                -- -------------------------------------
                -- -------------  Current Time:  3685ns
                WAIT FOR 170 ns;
                freq_data <= "0000000000000000000000000000000000000000000000000000000000000011";
                -- -------------------------------------
                -- -------------  Current Time:  3715ns
                WAIT FOR 30 ns;
                CHECK_out_write_mem_data("0000000000000000000000000000000000000000000000000000000000000010", 3715);
                CHECK_out_write_mem_index("00000000000000000000001000", 3715);
                -- -------------------------------------
                -- -------------  Current Time:  3885ns
                WAIT FOR 170 ns;
                freq_data <= "0000000000000000000000000000000000000000000000000000000000000100";
                -- -------------------------------------
                -- -------------  Current Time:  3915ns
                WAIT FOR 30 ns;
                CHECK_out_write_mem_data("0000000000000000000000000000000000000000000000000000000000000011", 3915);
                CHECK_out_write_mem_index("00000000000000000000010000", 3915);
                -- -------------------------------------
                -- -------------  Current Time:  4085ns
                WAIT FOR 170 ns;
                freq_valid <= '0';
                freq_data <= "0000000000000000000000000000000000000000000000000000000000000000";
                -- -------------------------------------
                -- -------------  Current Time:  4115ns
                WAIT FOR 30 ns;
                CHECK_out_write_mem_data("0000000000000000000000000000000000000000000000000000000000000100", 4115);
                CHECK_out_write_mem_index("00000000000000000000011000", 4115);
                -- -------------------------------------
                -- -------------  Current Time:  4315ns
                WAIT FOR 200 ns;
                CHECK_out_write_mem_strobe('0', 4315);
                -- -------------------------------------
                -- -------------  Current Time:  4485ns
                WAIT FOR 170 ns;
                freq_ts <= '1';
                freq_valid <= '1';
                freq_addr <= "0000000000000000000000000000000001111";
                freq_data <= "0000000000000000000000000000000000000000000000000000000000000001";
                -- -------------------------------------
                -- -------------  Current Time:  4685ns
                WAIT FOR 200 ns;
                freq_ts <= '0';
                freq_valid <= '0';
                freq_addr <= "0000000000000000000000000000000000000";
                freq_data <= "0000000000000000000000000000000000000000000000000000000000000000";
                -- -------------------------------------
                -- -------------  Current Time:  5115ns
                WAIT FOR 430 ns;
                CHECK_out_mem_read_enable('1', 5115);
                CHECK_out_mem_read_index("00000000000000000000010000", 5115);
                -- -------------------------------------
                -- -------------  Current Time:  5315ns
                WAIT FOR 200 ns;
                CHECK_out_mem_read_index("00000000000000000000010001", 5315);
                -- -------------------------------------
                -- -------------  Current Time:  5515ns
                WAIT FOR 200 ns;
                CHECK_out_mem_read_index("00000000000000000000010010", 5515);
                -- -------------------------------------
                -- -------------  Current Time:  5715ns
                WAIT FOR 200 ns;
                CHECK_out_mem_read_index("00000000000000000000010011", 5715);
                -- -------------------------------------
                -- -------------  Current Time:  5915ns
                WAIT FOR 200 ns;
                CHECK_out_mem_read_index("00000000000000000000010100", 5915);
                -- -------------------------------------
                -- -------------  Current Time:  6115ns
                WAIT FOR 200 ns;
                CHECK_out_mem_read_index("00000000000000000000010101", 6115);
                -- -------------------------------------
                -- -------------  Current Time:  6315ns
                WAIT FOR 200 ns;
                CHECK_out_mem_read_index("00000000000000000000010110", 6315);
                -- -------------------------------------
                -- -------------  Current Time:  6515ns
                WAIT FOR 200 ns;
                CHECK_out_mem_read_index("00000000000000000000010111", 6515);
                -- -------------------------------------
                -- -------------  Current Time:  6715ns
                WAIT FOR 200 ns;
                CHECK_out_mem_read_index("00000000000000000000011000", 6715);
                -- -------------------------------------
                -- -------------  Current Time:  6915ns
                WAIT FOR 200 ns;
                CHECK_out_mem_read_enable('0', 6915);
                CHECK_out_mem_read_index("00000000000000000000000000", 6915);
                -- -------------------------------------
                -- -------------  Current Time:  9115ns
                WAIT FOR 2200 ns;
                CHECK_out_done('1', 9115);
                -- -------------------------------------
                -- -------------  Current Time:  9315ns
                WAIT FOR 200 ns;
                CHECK_out_done('0', 9315);
                -- -------------------------------------
                -- -------------  Current Time:  9915ns
                WAIT FOR 600 ns;
                CHECK_out_mem_read_enable('1', 9915);
                -- -------------------------------------
                WAIT FOR 285 ns;

                IF (TX_ERROR = 0) THEN
                    STD.TEXTIO.write(TX_OUT, string'("No errors or warnings"));
                    STD.TEXTIO.writeline(RESULTS, TX_OUT);
                    ASSERT (FALSE) REPORT
                      "Simulation successful (not a failure).  No problems detected."
                      SEVERITY FAILURE;
                ELSE
                    STD.TEXTIO.write(TX_OUT, TX_ERROR);
                    STD.TEXTIO.write(TX_OUT,
                        string'(" errors found in simulation"));
                    STD.TEXTIO.writeline(RESULTS, TX_OUT);
                    ASSERT (FALSE) REPORT "Errors found during simulation"
                         SEVERITY FAILURE;
                END IF;
            END PROCESS;

    END testbench_arch;

