import java.awt.*;
import javax.swing.*;

public abstract class FPWM_Module extends JPanel {

	protected FPWMSim main;
	protected PrefManager pm;
	protected Graphics g;

	protected static int MEMORY_FETCH_DELAY = 8;
	protected static int RESULT_QUEUE_LENGTH = 8;

	protected long last_paint;

	public FPWM_Module(FPWMSim main, PrefManager pm) {
		this.main = main;
		this.pm = pm;
		main.getContentPane().add(this);
	}

	public abstract FPWM_DataPackage updateDataState(FPWM_DataPackage dataPackage);

	public Dimension getPreferredSize(){
		return new Dimension(1100,250);
	}


	public void paint(Graphics g) {
		//long time = System.currentTimeMillis();

		//if(time > last_paint + 25) {
		//	last_paint = time;
			do_paint(g);
		//}
	}

	public abstract void do_paint(Graphics g);

	public void drawBorder(Graphics g) {
		g.setColor(Color.BLACK);

		g.drawLine(2, 	 2,		1098,	2);
		g.drawLine(2, 	 3,		1098,	3);
		g.drawLine(2, 	 2,		2,		190);
		g.drawLine(3,	 2,		3,		190);
		g.drawLine(2, 	 190,	1098,	190);
		g.drawLine(2, 	 191,	1098,	191);
		g.drawLine(1097, 2,		1097,	190);
		g.drawLine(1098, 2,		1098,	190);
	}

}